/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of subfile.xs. Do not edit this file, edit subfile.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "subfile.xs"
/* -*- c -*- */
/*    subfile.xs
 *
 *    Copyright (C) 2001-2003, Nicholas Clark
 *
 *    You may distribute this work under the terms of either the GNU General
 *    Public License or the Artistic License, as specified in perl's README
 *    file.
 *
 */
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "perliol.h"

typedef struct {
  PerlIOBuf	base;
  Off_t		start;
  Off_t		end;	/* byte beyond the end. 0 will make file unbounded.  */
} PerlIOSubfile;


static IV
PerlIOSubfile_seek(pTHX_ PerlIO *f, Off_t offset, int whence)
{
  IV code;
  PerlIOSubfile *s = PerlIOSelf(f,PerlIOSubfile);
  Off_t new;

#if DEBUG_LAYERSUBFILE
  PerlIO_debug("PerlIOSubfile_seek f=%p offset=%08"UVxf" whence=%d "
	       "s->start=%08"UVxf" s->end=%08"UVxf"\n",
	       f, (UV)offset, whence, (UV)s->start, (UV)s->end);
#endif

  if (whence == SEEK_SET)
    offset = new = s->start + offset;
  else if (whence == SEEK_CUR)
    new = PerlIOBuf_tell(aTHX_ f) + offset;
  else if (whence == SEEK_END) {
    offset = new = s->end + offset;
    whence = SEEK_SET;
  } else
    return -1;


  if (new < s->start) {
#if DEBUG_LAYERSUBFILE
    PerlIO_debug("  new=%08"UVxf" whence=%d fell off start\n", (UV)new, whence);
#endif
    errno = EINVAL;
    return -1;
  }

  code = PerlIOBuf_seek(aTHX_ f, offset, whence);

#if DEBUG_LAYERSUBFILE
  PerlIO_debug("  new=%08"UVxf" whence=%d code=%d\n", (UV)new, whence,
	       (int) code);
#endif

  assert (PerlIOBuf_tell(aTHX_ f) >= s->start);
  return code;
}

static Off_t
PerlIOSubfile_tell (pTHX_ PerlIO *f)
{
  PerlIOSubfile *s = PerlIOSelf(f,PerlIOSubfile);
  Off_t real = PerlIOBuf_tell(aTHX_ f);

#if DEBUG_LAYERSUBFILE
  PerlIO_debug("PerlIOSubfile_tell f=%p real=%08"UVxf" return %08"UVxf
	       " s->start=%08"UVxf" s->end=%08"UVxf"\n",
	       f, (UV)real, (UV)(real-s->start), (UV)s->start, (UV)s->end);
#endif

  assert (real >= s->start);
  assert (s->end == 0 || (real < s->end));

  return real - s->start;
}

static IV
PerlIOSubfile_fill(pTHX_ PerlIO *f)
{
  PerlIOSubfile *s = PerlIOSelf(f,PerlIOSubfile);
  Off_t real = PerlIOBuf_tell(aTHX_ f);

#if DEBUG_LAYERSUBFILE
  PerlIO_debug("PerlIOSubfile_fill f=%p real=%08"UVxf
	       " s->start=%08"UVxf" s->end=%08"UVxf"\n",
	       f, (UV)real, (UV)s->start, (UV)s->end);
#endif

  if ((s->end == 0) || (real < s->end)) {
    PerlIOBuf *b = PerlIOSelf(f,PerlIOBuf);
    IV code = PerlIOBuf_fill(aTHX_ f);
    SSize_t avail;

#if DEBUG_LAYERSUBFILE
    PerlIO_debug("  code=%-3d avail=%08"UVxf" b->buf=%p b->end=%p\n", code,
		 (UV)(b->end - b->buf), b->buf, b->end);
#endif
    if (code)
      return code;

    avail = b->end - b->buf;
    if (s->end && ((real + avail) >= s->end)) {
      avail = s->end - real;
      b->end = b->buf + avail;
#if DEBUG_LAYERSUBFILE
    PerlIO_debug("  truncate avail=%08"UVxf" b->buf=%p b->end=%p\n", avail,
		 b->buf, b->end);
#endif
      assert (avail > 0);
    }
    return 0;
  }
  PerlIOBase(f)->flags |= PERLIO_F_EOF;
  return -1;
}

static SV *
PerlIOSubfile_getarg(pTHX_ PerlIO *f, CLONE_PARAMS *param, int flags)
{
  PerlIOSubfile *s = PerlIOSelf(f,PerlIOSubfile);
  SV *sv = newSVpvf("start=%08"UVxf",end=%08"UVxf, (UV)s->start, (UV)s->end);
  return sv ? sv : &PL_sv_undef;
}

static IV
PerlIOSubfile_pushed(pTHX_ PerlIO *f, const char *mode, SV *arg,
		     PerlIO_funcs *tab)
{
  IV code = 0;
  PerlIOSubfile *s = PerlIOSelf(f,PerlIOSubfile);

  STRLEN len;	/* This is effectively also a flag: 0 means "no arguments" */
  const char *argstr;
  bool is_UV;

  if (arg && SvOK(arg)) {
    if (SvIOK(arg) && !SvPOK(arg))
      len = is_UV = 1;
    else {
      is_UV = 0;
      argstr = SvPV(arg, len);
    }
  } else {
    argstr = NULL;
    len = 0;
  }

#if DEBUG_LAYERSUBFILE
  PerlIO_debug("PerlIOSubfile_pushed f=%p %s %s fl=%08"UVxf" s=%p\n",
	       f,PerlIOBase(f)->tab->name,(mode) ? mode : "(Null)",
	       PerlIOBase(f)->flags, s);
  if (argstr) {
    if (is_UV)
      PerlIO_debug("  arg=%08"UVxf"\n", SvUV(arg));
    else
      PerlIO_debug("  len=%d argstr=%.*s\n", (int)len, (int)len, argstr);
  }
#endif

  code = PerlIOBuf_pushed(aTHX_ f,mode,&PL_sv_undef,tab);
  if (code)
    return code;

  s->start = PerlIOBuf_tell(aTHX_ f);
  s->end = 0;

  if (PerlIOBase(f)->flags & PERLIO_F_CANWRITE)
    return -1;  /* Not having any of the write stuff.  */

  if (len) {
    if (is_UV) {
      s->end = s->start + SvUV(arg);
#if DEBUG_LAYERSUBFILE
      PerlIO_debug("  end is %08"UVxf"\n", (UV)s->end);
#endif
    } else {
      const char *end = argstr + len;
      dTHX;       /* fetch context */

      while (1) {
        const char *comma = memchr (argstr, ',', end - argstr);
        STRLEN this_len = comma ? (comma - argstr) : (end - argstr);
        const char *value = memchr (argstr, '=', this_len);

#if DEBUG_LAYERSUBFILE
        PerlIO_debug("  processing len=%d argstr=%.*s value=%p\n",
                     (int)this_len, (int)this_len, argstr, value);
#endif

        if (value) { /* value points at the '=' sign.  */
          STRLEN name_len = (value - argstr);
          int save_errno = errno;
          int relative = 0;
          Off_t offset;

          value++;
          while (isSPACE(*value))
            value++;
          if (*value == '+') {
            relative = 1;
            value++;
          } else if (*value == '-') {
            relative = -1;
            value++;
          }

          if (!isDIGIT(*value)) {
            errno = EINVAL;
            return -1;
          }

          errno = 0;
          offset = Strtoul (value, (char **) &value, 0); /* Guess the base */
          if (errno)
            return -1;
          errno = save_errno;

          while (isSPACE(*value))
            value++;
          if (value != (argstr + this_len)) {
#if DEBUG_LAYERSUBFILE
            PerlIO_debug("  failing this_len=%d argstr=%p value=%p, not %p,"
                         " offset=%08"UVxf"\n", (int)this_len, argstr, value,
                         (value + this_len), (UV)offset);
#endif
            errno = EINVAL;
            return -1;
          }

          if (name_len == 5 && memEQ (argstr, "start", 5)) {
            if (relative) {
              IV code = PerlIOBuf_seek(aTHX_ f, relative * offset, SEEK_CUR);
              if (code)
                return code;
              assert (PerlIOBuf_tell(aTHX_ f) == s->start + relative * offset);
              s->start += relative * offset;
#if DEBUG_LAYERSUBFILE
              PerlIO_debug("  rel start now %08"UVxf" %08"UVxf"\n",
                           (UV)s->start, (UV)PerlIOBuf_tell(aTHX_ f));
#endif
            } else {
              IV code = PerlIOBuf_seek(aTHX_ f, offset, SEEK_SET);
              if (code)
                return code;
              assert (PerlIOBuf_tell(aTHX_ f) == offset);
              s->start = offset;
#if DEBUG_LAYERSUBFILE
              PerlIO_debug("  abs start now %08"UVxf" %08"UVxf"\n",
                           (UV)s->start, (UV)PerlIOBuf_tell(aTHX_ f));
#endif
            }
          } else if (name_len == 3 && memEQ (argstr, "end", 3)) {
            if (relative)
              s->end = s->start + relative * offset;
            else
              s->end = offset;
#if DEBUG_LAYERSUBFILE
            PerlIO_debug("  end now %08"UVxf" relative=%d\n", (UV)s->end,
                         relative);
#endif
          } else {
            Perl_warn(aTHX_
                      "perlio: layer :subfile, unregonised argument \"%.*s\"",
                      (int)this_len, argstr);
          }
        } else {
          Perl_warn(aTHX_
                    "perlio: layer :subfile, argument \"%.*s\" has no value",
                    (int)this_len, argstr);
        }
        if (!comma)
          break;
        argstr = comma + 1;
      }
    }
  }
  return 0;
}

static SSize_t
PerlIO_write_fail(pTHX_ PerlIO *f, const void *vbuf, Size_t count)
{
  return -1;
}

PerlIO_funcs PerlIO_subfile = {
 sizeof(PerlIO_funcs),
 "subfile",
 sizeof(PerlIOSubfile),
 PERLIO_K_BUFFERED,
 PerlIOSubfile_pushed,
 PerlIOBase_noop_ok,
 PerlIOBuf_open,
 PerlIOBase_binmode,
 PerlIOSubfile_getarg,
 PerlIOBase_fileno,
 PerlIOBuf_dup,
 PerlIOBuf_read,
 PerlIOBuf_unread,
 PerlIO_write_fail,
 PerlIOSubfile_seek,
 PerlIOSubfile_tell,
 PerlIOBuf_close,
 PerlIOBuf_flush,
 PerlIOSubfile_fill,
 PerlIOBase_eof,
 PerlIOBase_error,
 PerlIOBase_clearerr,
 PerlIOBase_setlinebuf,
 PerlIOBuf_get_base,
 PerlIOBuf_bufsiz,
 PerlIOBuf_get_ptr,
 PerlIOBuf_get_cnt,
 PerlIOBuf_set_ptrcnt,
};

#line 336 "subfile.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 480 "subfile.c"
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_PerlIO__subfile); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_PerlIO__subfile)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif


    /* Initialisation Section */

#line 331 "subfile.xs"
	PerlIO_define_layer(aTHX_ &PerlIO_subfile);

#line 508 "subfile.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
